import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'ag_message.g.dart';

/// An AgMessage specialised message that the AggEcho Service works with.
abstract class AgMessage implements Built<AgMessage, AgMessageBuilder> {
  @nullable
  String get whatWasSaid;

  @nullable
  String get allTogether;

  @nullable
  int get fibValue;

  AgMessage._();

  factory AgMessage([updates(AgMessageBuilder b)]) = _$AgMessage;

  /// Serialisation for persistence and wire transfer.
  static Serializer<AgMessage> get serializer => _$agMessageSerializer;
}
