import 'package:chanworker/chanworker.dart';

import 'ag_message.dart';
import 'serializers.dart';

export 'ag_message.dart';
export 'serializers.dart';

/// Similar to the [AggregateEcho] service, except this one takes a Custom typed
/// [AgMessage] message.
class EchoingFib {
  final Channel<AgMessage> consumerChannel;

  String _previousStrings = '';
  int _callCount = 0;

  EchoingFib(this.consumerChannel) {
    consumerChannel.receivePort.listen(_handleRequest);
  }

  _handleRequest(AgMessage req) {
    _callCount++;
    int answer = _calFibForCall(_callCount);
    consumerChannel.dispatchPort.add(AgMessage((b) => b
      ..allTogether = _previousStrings += req.whatWasSaid
      ..fibValue = answer));
  }

  int _calFibForCall(int callCount) {
    if (callCount < 2) {
      return callCount;
    } else {
      return _calFibForCall(callCount - 2) + _calFibForCall(callCount - 1);
    }
  }
}

/// Only involved when loaded with worker.
main() {
  EchoingFib(WorkerChannelCounterPart<AgMessage>(serializer: serializers));
}
